<?php


require_once(plugin_dir_path(__FILE__) . 'xwp.php');
// require_once(plugin_dir_path(__FILE__) . 'Xpell/XUI/XUI.php');


class pageManager {

    // Properties

    //constructor
    public function __construct() {
        
    }

    public function register_apis() {
        global $_xwp;
        $_xwp->register_route('add-page', array($this,'add_page'));
        $_xwp->register_route('get-pages', array($this,"get_pages"));
        $_xwp->register_route('get-page', array($this,"get_page"));
        $_xwp->register_route('delete-page', array($this,"delete_page"));
        $_xwp->register_route('update-page', array($this,"update_page"));
    }

    function register_shortcode() {
        // add_shortcode('xpell_view', array($this, 'get_xpell_view'));
    }



    // // helper function that is activated by shortcode xpell_view
    // public function get_xpell_view() {
    //     $_xui = XUI::get_instance();
    //     $view = $_xui->add( array(
    //         '_type' => 'view',
    //         '_text' => 'Hello World',
    //         '_id' => 'xpell_view_id',
    //         'class' => 'xpell-ai',
    //         'style' => "background-color: red; color: white; padding: 10px;"
    //     ));
    //     return $view;
    // }

    public function add_page(WP_REST_Request $request) {
        // Get the page array from the request
        $new_page = $this->get_page_array($request);
    
        // Insert the page using wp_insert_post
        $page_id = wp_insert_post($new_page);
    
        // Check if the insertion was successful or if it returned an error
        if (!is_wp_error($page_id)) {
            // Return a successful response with the page ID
            $res = array(
                '_page_id' => $page_id,
                '_message' => 'Page added successfully'
            );
            return new WP_REST_Response($res, 200);
        } else {
            // If an error occurred, return the error message
            return new WP_REST_Response(array(
                '_error' => $page_id->get_error_message()
            ), 500);
        }
    }
    

    
    public function get_pages(WP_REST_Request $request) {
        $pid = $request->get_param('_id');
        $args = array(
            'post_type' => 'page',
            'posts_per_page' => -1,
        );
    
        if ($pid) {
            $args['p'] = $pid;
        }
    
        $query = new WP_Query($args);
        $pages = $query->posts;
    
        $response = array();
        foreach ($pages as $page) {
            $response[] = (array) $page; // Casting to array
        }
    
        return new WP_REST_Response($response, 200);
    }
    
    public function delete_page(WP_REST_Request $request) {
        $page_id = $request->get_param('_id');
        $result = wp_delete_post($page_id, true); // The second parameter 'true' forces deletion without moving to trash
    
        if ($result) {
            return new WP_REST_Response('Page deleted successfully', 200);
        } else {
            return new WP_REST_Response('Failed to delete page', 500);
        }
    }
    
    public function update_page(WP_REST_Request $request) {
        $page_id = $request->get_param('_id');
        $page_data = $this->get_page_array($request);
        $page_data['ID'] = $page_id;
        $result = wp_update_post($page_data);
    
        if (!is_wp_error($result)) {
            return new WP_REST_Response('Page updated successfully', 200);
        } else {
            return new WP_REST_Response('Failed to update page', 500);
        }
    }


    
    

    
}

?>
