<?php
// Xpell Wordpress Helper

//const
define("PLUGIN_BASE_ROUTE", 'aime/v1');

class XWP {
    
    public $aime_server_default_url = 'https://play.aimeverse.com';

    public $plugin_js_version = '1.0.9';

    public function create_guid() {
        return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
            wp_rand( 0, 0xffff ), wp_rand( 0, 0xffff ),
            wp_rand( 0, 0xffff ),
            wp_rand( 0, 0x0fff ) | 0x4000,
            wp_rand( 0, 0x3fff ) | 0x8000,
            wp_rand( 0, 0xffff ), wp_rand( 0, 0xffff ), wp_rand( 0, 0xffff )
        );
    }

    public function get_aime_nonce() {
        return get_option('aime_nonce');
    }

    public function save_aime_nonce($nonce) {
        update_option('aime_nonce', $nonce);
    }

    // public function add_aime_nonce($nonce_name) {
    //     $nonce = $this->get_aime_nonce();
    //     $token = $this->create_guid();
    //     if ($nonce == null) {
    //         $nonce = new stdClass();
    //     } else {
    //         $nonce = json_decode($nonce);
    //     }
    //     $nonce->$nonce_name = array(
    //         'token' => $token,
    //         'created' => new DateTime()
    //     );
    //     $this->save_aime_nonce(json_encode($nonce));
    //     return $token;
    // }

    public function add_aime_nonce($nonce_name) {
        $nonce = $this->get_aime_nonce();
        $token = $this->create_guid();
    
    
        // If nonce is null, initialize it as an empty array
        if ($nonce == null) {
            $nonce = new stdClass();
        } else {
            $nonce = json_decode($nonce);
        }
    
        // Store created time as a formatted string
        $nonce->$nonce_name = array(
            'token' => $token,
            'created' => (new DateTime())->format(DateTime::ISO8601) // Store as string
        );
    
        // Save the updated nonce back
        $this->save_aime_nonce(wp_json_encode($nonce));
        return $token;
    }

    public function verify_aime_nonce_token($nonce_name, $token) {
        $nonceJson = json_decode($this->get_aime_nonce());
        if ($nonceJson == null) {
            return false;
        }
        $nonce = $nonceJson->$nonce_name;
        if ($nonce == null) {
            return false;
        }
        $now = new DateTime();
        $created = new DateTime($nonce->created); // Still the same
        $diff = $now->diff($created);
        // Check for 5 minutes
        if ($diff->i > 5) {
            return false;
        }

        return $nonce->token == $token;

        // if ($nonce->token == $token){
        //     // delete the nonce
        //     unset($nonceJson->$nonce_name);
        //     $this->save_aime_nonce(json_encode($nonceJson));
        //     return true;
        // } else {
        //     return false;
        // }
    
    }

    
    
    



    public function get_plugin_dir() {
        return plugin_dir_path(__FILE__);
    }
    
    public function get_plugin_url() {
        return plugin_dir_url(__FILE__);
    }

    public function register_route($route, $callback) {
        register_rest_route( PLUGIN_BASE_ROUTE , '/' . $route . '/', array(
            'methods' => 'POST',
            'callback' => $callback,
            'permission_callback' => '__return_true', // Adjust for authentication if needed
        ));
    }


    
    public function register_shortcode($tag, $callback) {
        add_shortcode($tag, $callback);
    }

    public function import_css() {
        wp_enqueue_style(
            'xpell-style', // Handle name for the stylesheet
            $this->get_plugin_url() .'../client-lib/xpell/xpell.css', // URL of the stylesheet
            array(), // Dependencies, if any (e.g., other styles)
            '1.0.0', // Version of the stylesheet (optional)
            'all' // Media type (optional, default is 'all')
        );
        wp_enqueue_style(
            'aime-style', // Handle name for the stylesheet
            $this->get_plugin_url() .'../client-lib/aime-wp-js/aime-style.css', // URL of the stylesheet
            array(), // Dependencies, if any (e.g., other styles)
            '1.0.0', // Version of the stylesheet (optional)
            'all' // Media type (optional, default is 'all')
        );

        wp_enqueue_style(
            'xpell-ai-style', // Handle name for the stylesheet
            $this->get_plugin_url() .'style/xpell-ai.css', // URL of the stylesheet
            array(), // Dependencies, if any (e.g., other styles)
            '1.0.0', // Version of the stylesheet (optional)
            'all' // Media type (optional, default is 'all')
        );
       
       
        // <link rel="stylesheet" type="text/css" href="<?php echo $this->get_plugin_url() . '../css/xpell.css'; ">
        //<link rel="stylesheet" type="text/css" href="<?php echo $this->get_plugin_url() . '../css/aime-style.css'; ">
       
    }

    

    function add_custom_button_to_post_list() {
        // $screen = get_current_screen();
        // // Check if we are on the post list page
        // if ($screen->post_type == 'post') {
        //     // Output the button next to "Add New Post"
        //     echo '<a href="?page=aime-menu"  class="button button-primary" style="margin-left: 10px;">Generate with AIME</a>';
        // }
    }
    // page=aime-menu
    


    function add_aime_scripts() {
        global $_xwp;

        $scripts = $_xwp->get_aime_scripts_urls();
        $aime_settings = get_option('aime_settings');
        // print aime settings
       

        ?>
       
       <script type="module" >
            import { _xd ,_x,XUI,XDB} from "<?php echo esc_html($scripts['xpell_script']) ?>";
     
            
            _xd._o["aime_public_folder"] = "<?php echo esc_html($scripts['aime_public_folder']) ?>";
            _xd._o["server-settings"]= {
                    _token: "<?php echo esc_html($aime_settings['api_key']) ?>",
                    _verbose: true,
                    _player_id: "xplayer",
                    _player_class: "xplayer",
                    _player_parent: "aime-container",
                    _theme: "dark",
                    _public_folder:"<?php echo esc_html($scripts['aime_public_folder'])?>",
                    _wp_user_id: "string",
                    _wp_user_email: "string",
                    _wp_site_url: "string",
                    _wp_site_name: "string",
                    _wp_site_description: "string",
                    _wp_site_icon: "string",
                    _channel_id: "<?php echo esc_html($aime_settings['channel_id']) ?>",
                    _aime_server_url: "<?php echo esc_html($aime_settings['aime_server_url']) ?>"
                }

                
            // _x.start();
            
             _x.verbose = true;
            // _x.info()
            XDB.info();
            XDB.encode = true;

            _x.loadModules(XUI);
            _x.start();

            
        </script>
        <?php
    }

    function aime_plugin_enqueue_scripts() {        

        // wp_register_script('aime-custom-gutenberg-script', plugin_dir_url(__FILE__) . '../js/aime-editor.js');
        wp_enqueue_script_module(
            'aime-custom-gutenberg-script',
            plugin_dir_url(__FILE__) . '../js/aime-editor.js', // Path to your JS file
            array('wp-blocks', 'wp-element', 'wp-edit-post', 'wp-data', 'wp-plugins', 'wp-components', 'wp-i18n'), // Gutenberg dependencies
            filemtime(plugin_dir_path(__FILE__) . '../js/aime-editor.js'), // Cache-busting
            "1.6" // Version number
        );

 
        
        // wp_script_add_data('aime-custom-gutenberg-script', 'type', 'module');


    }    
    
    function get_aime_scripts_urls() {
        $aime_public_folder = plugin_dir_url(__FILE__) . '../client-lib/aime-wp-js/';

        return array(
            'aime_public_folder' => $aime_public_folder,
            'aime_script' => $aime_public_folder .  'aime-wp-js.es.js?v=' . $this->plugin_js_version,
            'xpell_script' => plugin_dir_url(__FILE__) . '../client-lib/xpell/xpell.es.js'
        );
    }

    

     
    
}




$_xwp = new XWP();

?>
